%define _enable_debug_packages	%{nil}
%define debug_package		%{nil}

# workaround some rpm bug
%define _requires_exceptions statically\\|linked\\|devel(/lib/libNoVersion)\\|bash

# disable stack protector, build doesn't work with it
%define _ssp_cflags %{nil}

%define	mainver	0.9.28
%define	subver	1

Summary:	A C library optimized for size useful for embedded applications
Name:		uClibc
Version:	%{mainver}.%{subver}
Release:	%mkrel 5
License:	LGPL
Group:		System/Libraries
URL:		http://uclibc.org/
Source0:	http://uclibc.org/downloads/%{name}-%{version}.tar.bz2
Source1:	http://uclibc.org/downloads/%{name}-%{version}.tar.bz2.sign
Patch0:		uClibc-0.9.27-mdkconf.patch
Patch1:		uClibc-newsoname.patch
Patch2:		uClibc-alpha.patch
Patch3:		uClibc-toolchain-wrapper.patch
Patch4:		uClibc-targetcpu.patch
Patch5:		uClibc-O_DIRECT.patch
Patch6:		uClibc-sparc.patch
Patch7:		uClibc-x86_64.patch
BuildRequires:	which kernel-source
#Requires:	binutils gcc-cpp = %{gcc_version}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
uClibc (pronounced yew-see-lib-see) is a C library for developing
embedded Linux systems. It is much smaller than the GNU C Library,
but nearly all applications supported by glibc also work perfectly
with uClibc. Porting applications from glibc to uClibc typically
involves just recompiling the source code. uClibc even supports
shared libraries and threading. It currently runs on standard
Linux and  MMU-less (also known as uClinux) systems with support
for alpha, ARM, cris, i386, i960, h8300, m68k, mips/mipsel,
PowerPC, SH, SPARC, and v850 processors.

If you are building an embedded Linux system and you find that
glibc is eating up too much space, you should consider using
uClibc. If you are building a huge fileserver with 12 Terabytes of
storage, then using glibc may make more sense. Unless, for
example, that 12 Terabytes will be Network Attached Storage and
you plan to burn Linux into the system's firmware...

%package	devel
Summary:	Development files for uClibc
Group:		Development/C
Requires:	%{name} = %{version}-%{release}
#Requires:	gcc = %{gcc_version}

%description	devel
Small libc for building embedded applications.

%package	static-devel
Summary:	Static uClibc libratries
Group:		Development/C
Requires:	%{name}-devel = %{version}-%{release}
Provides:	libc-static

%description	static-devel
Static uClibc libratries.

%prep
%setup -q
#cp %SOURCE2 ldso/ldso/x86_64
%patch0 -p1 -b .mdkconf
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
#%patch6 -p1
%patch7 -p1

mkdir -p extra/gcc-uClibc
cp -a extra/gcc-uClibc extra/tmpgcc
 
find -name ".svn" | xargs rm -rf

%build
make defconfig TARGET_ARCH="%{_arch}" TARGET_CPU="%{_target_cpu}" KERNEL_SOURCE=%{_prefix} HOSTCFLAGS="%{optflags}" OPTIMIZATION="%{optflags} -Os" GCC_BIN="%{_bindir}/gcc"

rm -f include/bits/uClibc_config.h

%make TARGET_ARCH="%{_arch}" TARGET_CPU="%{_target_cpu}" KERNEL_SOURCE=%{_prefix} HOSTCFLAGS="%{optflags}" OPTIMIZATION="%{optflags} -Os" GCC_BIN="%{_bindir}/gcc"

%check
#cd test
#make

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}

make TARGET_ARCH="%{_arch}" TARGET_CPU="%{_target_cpu}" PREFIX=%{buildroot} install
make TARGET_ARCH="%{_arch}" TARGET_CPU="%{_target_cpu}" PREFIX=%{buildroot} -C extra/gcc-uClibc install

# We need to build a temporary compiler that looks into our
# build directory instead of /usr
pushd extra/tmpgcc
    perl -pi -e "s/^all:/DEVEL_PREFIX=\.\.\/\nall:/;" Makefile
    %make TARGET_ARCH="%{_arch}" TARGET_CPU="%{_target_cpu}" KERNEL_SOURCE=%{_prefix} HOSTCFLAGS="%{optflags}" OPTIMIZATION="%{optflags} -Os" GCC_BIN="%{_bindir}/gcc"
popd

# Utils don't build with regular GCC, we need to use the temporary
# compiler above.
pushd utils
    perl -pi -e "s/Rules\.mak/Rules\.mak\nCC=\.\.\/extra\/tmpgcc\/%{_target_cpu}-uclibc-gcc/;" Makefile
    perl -pi -e "s/-s \\\\/-s -static \\\\/g;" Makefile
    perl -pi -e "s/R_PREFIX/RUNTIME_PREFIX/g;" Makefile
    perl -pi -e "s|UCLIBC_RUNTIME_PREFIX \"|\"%{_prefix}/%{_target_cpu}-linux-uclibc/|g;" ../ldso/include/ld_elf.h
    perl -pi -e "s|UCLIBC_RUNTIME_PREFIX \"|\"%{_prefix}/%{_target_cpu}-linux-uclibc/|g;" ldd.c
    perl -pi -e "s|UCLIBC_RUNTIME_PREFIX \"|\"%{_prefix}/%{_target_cpu}-linux-uclibc/|g;" ldconfig.c
    %make TARGET_ARCH="%{_arch}" TARGET_CPU="%{_target_cpu}" KERNEL_SOURCE=%{_prefix} HOSTCFLAGS="%{optflags}" OPTIMIZATION="%{optflags} -Os" GCC_BIN="%{_bindir}/gcc"
    cp ldd %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/bin/%{_target_cpu}-uclibc-ldd
    ln -sf ../../bin/%{_target_cpu}-uclibc-ldd %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc%{_bindir}/ldd
    mkdir -p %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/sbin
    cp ldconfig %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/sbin
popd
mkdir -p %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/etc

# convenience function
cat > %{buildroot}%{_bindir}/uclibc << EOF
#!/bin/sh
export PATH=%{_prefix}/%{_target_cpu}-linux-uclibc%{_bindir}:\$PATH
\$@
EOF

%ifarch ppc ppc64
    ln -sf ppc-linux-uclibc %{buildroot}%{_prefix}/powerpc-linux-uclibc
%endif

# these links are *needed* (by stuff in bin/)
#for f in %{buildroot}%{_prefix}/%{_arch}-linux-uclibc%{_bindir}/* ; do
#    ln -sf ../../bin/%{_arch}-uclibc-`basename $f` $f
#done

#find %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include -name CVS | xargs rm -rf

# OE: don't ship these?
rm -rf %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/asm
rm -rf %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/linux
rm -rf %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/scsi

#(peroyvind) rpm will make these symlinks relative
ln -snf /usr/include/asm %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/asm
ln -snf /usr/include/linux %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/linux
ln -snf /usr/include/scsi %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/scsi

# at least nuke this one...
rm -rf %{buildroot}%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/linux/modules

%clean
rm -rf %{buildroot}

%files
%defattr(644,root,root,755)
%doc README
%dir %{_prefix}/%{_target_cpu}-linux-uclibc
%ifnarch %{sunsparc}
%dir %{_prefix}/%{_target_cpu}-linux-uclibc/lib
%dir %{_prefix}/%{_target_cpu}-linux-uclibc/etc
%dir %{_prefix}/%{_target_cpu}-linux-uclibc/sbin
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/sbin/*
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/ld-*
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/lib*%{mainver}.so
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/lib/lib*.so.0
%endif
%ifarch ppc ppc64
%{_prefix}/powerpc-linux-uclibc
%endif

%files devel
%defattr(644,root,root,755)
%doc docs/* docs/uclibc.org/*.html COPYING.LIB Changelog TODO
%dir %{_prefix}/%{_target_cpu}-linux-uclibc/usr/bin
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/bin/*
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/bin/*
%attr(0755,root,root) %{_bindir}/uclibc
#%{_prefix}/%{_target_cpu}-linux-uclibc/usr
#%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/crt0.o
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/crt1.o
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/crti.o
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/crtn.o
%ifnarch %{sunsparc}
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/Scrt1.o
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/librt.so
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libnsl.so
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libpthread*.so*
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libc.so
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libcrypt.so
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libdl.so
%attr(02755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libm.so
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libresolv.so
%attr(0755,root,root) %{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libutil.so
%endif
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include

%files static-devel
%defattr(644,root,root,755)
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/lib*.a




%changelog
* Wed Jun 18 2008 Thierry Vignaud <tvignaud@mandriva.com> 0.9.28.1-5mdv2009.0
+ Revision: 225895
- rebuild

* Mon Mar 24 2008 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.9.28.1-4mdv2008.1
+ Revision: 189752
- rebuild against gcc 4.2.3
- s/-mtune=pentiumpro/-mtune=generic/

* Tue Mar 04 2008 Oden Eriksson <oeriksson@mandriva.com> 0.9.28.1-3mdv2008.1
+ Revision: 178883
- rebuild

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Aug 22 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.9.28.1-2mdv2008.0
+ Revision: 68745
- Rebuild, and disable _ssp_cflags as build doesn't work with it.


* Tue Feb 06 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.9.28.1-1mdv2007.0
+ Revision: 116708
- update to 0.9.28.1
  fix x86_64 build (P7)
  build on all archs

* Tue Feb 06 2007 Oden Eriksson <oeriksson@mandriva.com> 0.9.28-8mdv2007.1
+ Revision: 116671
- fix deps
- remove the gcc_version macro expansion
- disable the unused gcc_version macro expansion (second try)
- disable the unused gcc_version macro expansion
- Import uClibc

* Sun Oct 01 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.28-8mdv2007.0
- x86_64 is not well supported, so exclude it

* Thu Sep 28 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.28-7mdv2007.0
- rebuild

* Thu Sep 28 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.28-6mdv2007.0
- sync with the mille-xterm project (0.9.26-5mdk)

* Wed Sep 27 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.9.28-5mdv2007.0
- split out toolchain wrapper from one huge patch, use patches from PLD
- force correct gcc for toolchain to use
- cleanups

* Tue Aug 22 2006 Oden Eriksson <oeriksson@mandriva.com> 0.9.28-4mdv2007.0
- rebuild

* Sat Apr 08 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.9.28-3mdk
- rebuild against new gcc
- force dependecy on current gcc version

* Thu Jan 19 2006 Stew Benedict <sbenedict@mandriva.com> 0.9.28-2mdk
- buildrequires, x86_64 build (missing x86_64/resolve.S)

* Wed Aug 31 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.9.28-1mdk
- 0.9.28
- move test to new %%check stage (disabled)
- minor tweak to P0
- get rid of warning about obsoletes -malign-{loops,jumps}

* Fri Apr 29 2005 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.9.27-5.20050428mdk
- update to latest svn snapshot to fix x86_64 build

* Wed Apr 27 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.27-4mdk
- fix sparc build

* Tue Mar 08 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.27-2mdk
- no multiarch, rebuild for latest multiarch-utils
- compile for i586 with optimizations
- get rid of gcc warnings

* Tue Feb 15 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.27-1mdk
- 0.9.27
- regenerate P0
- drop P1 & P2
- multiarch

* Sat Dec 25 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-5mdk
- fix problem with kernel_types.h (P2 from CVS)

* Sat Dec 25 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-4mdk
- do not ship own kernel-headers, compile against systems (less hackish:)
- require also %%{release} for subpackages
- cleanups

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-3mdk
- urg?!?!? get rid of weird dependency that came out of nowhere:(

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-2mdk
- fix paths..

* Fri Dec 24 2004 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.9.26-1mdk
- 0.9.26 (with lots of suse hacks to make it build, probably needs some more tweaking..:\)

